// ignore_for_file: use_build_context_synchronously
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import '../../../../BuilderField/shared/ui/entity_details.dart';
import '../State_viewModel/State_view_model_screen.dart';
import 'State_update_entity_screen.dart';

class StateDetailsScreen extends StatefulWidget {
  final Map<String, dynamic> entity;

  const StateDetailsScreen({
    super.key,
    required this.entity,
  });

  @override
  State<StateDetailsScreen> createState() => _StateDetailsScreenState();
}

class _StateDetailsScreenState extends State<StateDetailsScreen> {
  void _navigateToUpdateScreen(Map<String, dynamic> entity) {
    Navigator.push(
      context,
      MaterialPageRoute(
        builder: (context) => ChangeNotifierProvider(
          create: (context) => StateViewModelScreen(),
          child: StateUpdateEntityScreen(entity: entity),
        ),
      ),
    ).then((_) {
      // Refresh the details screen with updated data
      setState(() {});
    });
  }

  void _showDeleteDialog(Map<String, dynamic> entity) {
    showDialog(
      context: context,
      builder: (BuildContext context) {
        return AlertDialog(
          title: const Text('Confirm Deletion'),
          content: const Text('Are you sure you want to delete this State?'),
          actions: [
            TextButton(
              child: const Text('Cancel'),
              onPressed: () {
                Navigator.of(context).pop();
              },
            ),
            TextButton(
              child: const Text('Delete'),
              onPressed: () async {
                Navigator.of(context).pop();
                final vm =
                    Provider.of<StateViewModelScreen>(context, listen: false);
                final success = await vm.deleteEntity(entity['id']);
                if (success && mounted) {
                  Navigator.pop(context); // Go back to list
                }
              },
            ),
          ],
        );
      },
    );
  }

  @override
  Widget build(BuildContext context) {
    return Consumer<StateViewModelScreen>(
      builder: (context, viewModel, child) {
        return EntityDetails(
          entity: widget.entity,
          onEdit: (entity) => _navigateToUpdateScreen(entity),
          onDelete: (entity) => _showDeleteDialog(entity),
          title: 'State',
          displayFields: [
  {'key': 'state_name', 'label': 'state name', 'type': 'text'},

  {'key': 'description', 'label': 'Description', 'type': 'textarea'},

  {'key': 'active', 'label': 'Active', 'type': 'toggle_switch'},

  {'key': 'country_name', 'label': 'country name', 'type': 'text'},

          ],
          isLoading: viewModel.isLoading,
        );
      },
    );
  }
}
